--If a Command has "NOTESKIN:GetMetricA" in it, that means it gets the command from the metrics.ini, else use cmd(); to define command.
--If you dont know how "NOTESKIN:GetMetricA" works here is an explanation.
--NOTESKIN:GetMetricA("The [Group] in the metrics.ini", "The actual Command to fallback on in the metrics.ini");

local sButton = Var "Button"
local pn = Var "Player"

local Judgment = NOTESKIN:GetPath("JudgeNCombo/Fallback","Judgment")
local Combo = NOTESKIN:GetPath("JudgeNCombo/Fallback","Combo")

local Reverse = string.find(GAMESTATE:GetPlayerState(pn):GetPlayerOptionsString("ModsLevel_Preferred"), "Reverse");

local button_name = 
{
	Left = "LeftRight",
	Right = "LeftRight",
	Up = "UpDown",
	Down = "UpDown",
}

local t = Def.ActorFrame {
	PressCommand=function(self) sReceptor[sButton]:queuecommand("Press") end;
	LiftCommand=function(self) sReceptor[sButton]:queuecommand("Lift") end;
	OnCommand=function(self)
	
		if loadcustomjudgeandcombo == nil then loadcustomjudgeandcombo = {}	end
	
		--Remove old Judge and Combo and load our own.
		if loadcustomjudgeandcombo[pn] == nil then
			local X = SCREENMAN:GetTopScreen():GetChild("Player"..ToEnumShortString(pn)):GetX()
			local Y = SCREENMAN:GetTopScreen():GetChild("Player"..ToEnumShortString(pn)):GetY()
			SCREENMAN:GetTopScreen():GetChild("Player"..ToEnumShortString(pn)):GetChild("Judgment"):visible(false)
			SCREENMAN:GetTopScreen():GetChild("Player"..ToEnumShortString(pn)):GetChild("Combo"):visible(false)
			SCREENMAN:GetTopScreen():GetChild("Overlay"):AddChildFromPath(Judgment)
			SCREENMAN:GetTopScreen():GetChild("Overlay"):AddChildFromPath(Combo)
			SCREENMAN:GetTopScreen():GetChild("Overlay"):GetChild("Judgment"):xy(X,Y);
			if Reverse then
				SCREENMAN:GetTopScreen():GetChild("Overlay"):GetChild("Combo"):xy(X,Y-160);
				SCREENMAN:GetTopScreen():GetChild("Overlay"):GetChild("Judgment"):xy(X,Y+40);
			else	
				SCREENMAN:GetTopScreen():GetChild("Overlay"):GetChild("Combo"):xy(X,Y+160);
				SCREENMAN:GetTopScreen():GetChild("Overlay"):GetChild("Judgment"):xy(X,Y-40);
			end
			loadcustomjudgeandcombo[pn] = true
		end
		
		getc = SCREENMAN:GetTopScreen():GetChild("Player"..ToEnumShortString(pn)):GetChild("NoteField"):get_column_actors()
		for i2 in pairs(getc) do
			if Reverse then
				getc[i2]:y(-32)
			else
				getc[i2]:y(32)
				self:zoomy(-1)
			end
		end
		
		sReceptor[sButton]:queuecommand("On")
		
		self:sleep(0.5)
		self:queuecommand("reset")
		
	end;
	
	resetCommand=function(self) 
		loadcustomjudgeandcombo = nil 
	end;
	
	Def.Quad {
		OnCommand=cmd(zoomto,64,9999;diffuse,0,0,0,0.4);	
	};
	
	Def.Sprite {
		OnCommand=cmd(y,-8);
		Texture=NOTESKIN:GetPath( 'Button', "Bar" );
	};	
	Def.Sprite {
		OnCommand=cmd(y,-120;diffusealpha,0);
		Texture=NOTESKIN:GetPath( 'Button', "Light" );
		PressCommand=cmd(diffusealpha,1);
		LiftCommand=cmd(stoptweening;sleep,0.05;linear,0.1;diffusealpha,0);
	};
};
return t;
